package org.apache.bcel.generic;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import org.apache.bcel.generic.ClassGenException;
import org.apache.bcel.generic.ConstantPoolGen;
import org.apache.bcel.generic.ConstantPushInstruction;
import org.apache.bcel.generic.Instruction;
import org.apache.bcel.generic.Type;
import org.apache.bcel.generic.Visitor;

public class DCONST extends Instruction implements ConstantPushInstruction {
  private double value;
  
  DCONST() {}
  
  public DCONST(double f) {
    super((short)14, (short)1);
    if (f == 0.0D) {
      setOpcode((short)14);
    } else if (f == 1.0D) {
      setOpcode((short)15);
    } else {
      throw new ClassGenException("DCONST can be used only for 0.0 and 1.0: " + f);
    } 
    this.value = f;
  }
  
  public void accept(Visitor v) {
    v.visitPushInstruction(this);
    v.visitStackProducer(this);
    v.visitTypedInstruction(this);
    v.visitConstantPushInstruction(this);
    v.visitDCONST(this);
  }
  
  public Type getType(ConstantPoolGen cp) {
    return Type.DOUBLE;
  }
  
  public Number getValue() {
    return Double.valueOf(this.value);
  }
}
